<?php
//
// by Razor
// igshat@gawab.com
//

define('PROJECT_FILE', 'nologin');
include_once(dirname(__FILE__).'/../common.php');
include_once(dirname(__FILE__).'/../lib/func.log.php');

// PARAMETERS
if( empty($_SERVER['HTTP_USER_AGENT']) ) {
    if( empty($_SERVER['argv'][1]) ) die("Bad timeout");
    $stimeout = intval($_SERVER['argv'][1]);
} else {
    if( _safe_var($_GET['key'])!=$DBCONF['key_code'] ) die("Bad key word parameter");
    if( empty($_GET['timeout']) ) die("Bad timeout");
    $stimeout = intval($_GET['timeout']);
    if( $CONF['demo'] ) { $stimeout = 60; echo "Demo mode. Request timeout = 60 sec"; }
}

// INIT
set_time_limit(0);
ignore_user_abort(1);
ob_implicit_flush();

echo "<h2>Proxy checking</h2><pre>\r\n";
$stime = time();
slog('Started (Proxy Checker)', SLOG_SYS);

// CURL
if( !function_exists('curl_exec') ) slog('cURL library is not found', SLOG_ERR, 1);
$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, $DBCONF['info_url']);
curl_setopt($ch, CURLOPT_TIMEOUT, $DBCONF['request_timeout']);
curl_setopt($ch, CURLOPT_USERAGENT, $CONF['user_agent']);
curl_setopt($ch, CURLOPT_HEADER, 0);
curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 0);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_REFERER, "proxy_test_referer" );
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_POSTFIELDS, "ptest=proxy_test_post" );
curl_setopt($ch, CURLOPT_COOKIE, "ptest=proxy_test_cookie" );

// LOAD SECURITY PARAMETERS
$security = array();
if( preg_match_all("|([^\r\n]+)|", $DBCONF['security'], $m) ) {
    foreach($m[1] as $v)
        $security[] = trim($v);
}
else slog('Empty security parameters', SLOG_ERR, 1);

// RESET "STOP" PARAMETER
mysql_query("UPDATE `".$CONF['tbl_conf']."` SET value='0' WHERE name='stop'") or die(mysql_error());

//
// START CHECKING
//
do {
    // TAKE PROXIES PART
    mysql_query("LOCK TABLES `".$CONF['tbl_proxy']."` WRITE") or die(mysql_error());
    $pr_res = mysql_query("SELECT id, host, port, country, country_code  FROM `".$CONF['tbl_proxy']."` WHERE `date` IS NULL OR UNIX_TIMESTAMP(`date`) <= (UNIX_TIMESTAMP()-".intval($DBCONF['check_interval']).") ORDER BY `date` LIMIT 0,".intval($CONF['part_size'])) or die(mysql_error());
    if(mysql_num_rows($pr_res)) {
		$ids = array();
		while( ($row=mysql_fetch_assoc($pr_res))!=false ) $ids[] = $row['id'];
	    mysql_query("UPDATE `".$CONF['tbl_proxy']."` SET date=NOW() WHERE id IN(".implode(",",$ids).")") or die(mysql_error());
	}
    mysql_query("UNLOCK TABLES") or die(mysql_error());

    if(($num_rows=mysql_num_rows($pr_res))==0) { slog("Nothing to check"); break; }
    mysql_data_seek($pr_res, 0);
    slog("Taked part: ".$num_rows);
    
    // CHECK PROXIES PART
    while( ($proxy=mysql_fetch_assoc($pr_res))!=false ) {

	    // CHECK FOR "STOP" PARAMETER
	    $res = mysql_query("SELECT value as stop FROM `".$CONF['tbl_conf']."` WHERE name='stop'") or die(mysql_error());
	    if(mysql_result($res,0)) slog("Terminated by user",SLOG_SYS,1);
	    mysql_free_result($res);
    	
	    // PING
	    $ping_time = 0;
	    if( $DBCONF['ping'] ) {
	        $out = array();
	        exec(preg_replace("#\[ip\]#i", escapeshellarg($proxy['host']), $CONF['ping_cmd']), $out);
	        if( preg_match("#time\s?=\s?(\d+)#i",_safe_var($out[1]),$m)
	        or  preg_match("#time\s?=\s?(\d+)#i",_safe_var($out[0]),$m) ) {
	            $ping_time = $m[1];
	        } else {
	            slog("Unworked (ping) [".$proxy['host'].':'.$proxy['port']."]");
	            mysql_query("DELETE FROM `".$CONF['tbl_proxy']."` WHERE id=".intval($proxy['id'])) or die(mysql_error());
	            continue;
	        }
	    }
	
	    // CHECK PROXY
	    curl_setopt($ch, CURLOPT_PROXY, $proxy['host'].':'.$proxy['port'] );
	    $content = curl_exec($ch);
	    if( !stristr($content, "REQUEST_INFO_PAGE_4896485_CODE") ) {
	        slog("Unworked [".$proxy['host'].':'.$proxy['port']."] ".curl_error($ch));
	        mysql_query("DELETE FROM `".$CONF['tbl_proxy']."` WHERE id=".intval($proxy['id'])) or die(mysql_error());
	    }
	    else {
	        // TIME
	        $con_time = curl_getinfo($ch, CURLINFO_CONNECT_TIME);
	        $tot_time = curl_getinfo($ch, CURLINFO_TOTAL_TIME);
	
	        // POST
	        stristr($content, "proxy_test_post") ?
	        $post = 1 : $post = 0;
	
	        // REFERER
	        stristr($content, "proxy_test_referer") ?
	        $ref = 1 : $ref = 0;
	
	        // COOKIES
	        stristr($content, "proxy_test_cookie") ?
	        $cookies = 1 : $cookies = 0;
	
	        // ANONYMOUS
	        $anon = 0;
	        if( $DBCONF['anon_determ'] ) {
	            $anon = 1;
	            foreach($security as $v) {
	                if( stristr($content, $v) ) { $anon = 0; break; }
	            }
	            if($anon) {
	                // TEST FOR HIGHT ANONYMITY
	                $anon = 2;
	                if( preg_match_all("|([^\r\n]+)=([^\r\n]+)|", $content, $m, PREG_SET_ORDER) )
	                    foreach($m as $v) {
	                        if( $v[1]=='HTTP_X_FORWARDED_FOR'
	                        or $v[1]=='HTTP_X_FORWARDED'
	                        or $v[1]=='HTTP_X_COMING_FROM'
	                        or $v[1]=='HTTP_FORWARDED_FOR'
	                        or $v[1]=='HTTP_FORWARDED'
	                        or $v[1]=='HTTP_COMING_FROM'
	                        or $v[1]=='HTTP_VIA'
	                        or $v[1]=='HTTP_XROXY_CONNECTION'
	                        or $v[1]=='HTTP_PROXY_CONNECTION' ) $anon = 1;
	                    }
	            }
	        }
	
	        // COUNTRY
	        $country = $proxy['country'];
	        $country_code = $proxy['country_code'];
	        if( $DBCONF['country_determ'] and empty($country) ) {
		        $ip = preg_match("#^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$#",$proxy['host'])	?
		        	$proxy['host']
		        :	gethostbyname($proxy['host']);
	            $longip = sprintf("%u", ip2long($ip));
	            $sql = "SELECT name, zone2 FROM `".$CONF['tbl_country']."` "
	                 . "WHERE ip_start<".$longip." "
	                 . "AND ip_end>".$longip." "
	                 . "LIMIT 0,1";
	            $res = mysql_query($sql) or die(mysql_error());
	            if(mysql_num_rows($res)) {
	            	$row = mysql_fetch_assoc($res);
	                $country = $row['name'];
	                $country_code = $row['zone2'];
	            }
	            mysql_free_result($res);
	        }
	
	        // UPDATE
	        $sql = "UPDATE `".$CONF['tbl_proxy']."` SET "
	             . "pingtime=".intval($ping_time).", "
	             . "contime=".doubleval($con_time).", "
	             . "time=".doubleval($tot_time).", "
	             . "work=1, "
	             . "post=".$post.", "
	             . "ref=".$ref.", "
	             . "anon=".$anon.", "
	             . "cookies=".$cookies.", "
	             . "country='".addslashes($country)."', "
	             . "country_code='".addslashes($country_code)."' "
	             . "WHERE id=".intval($proxy['id']);
	        mysql_query($sql) or die(mysql_error());
	        slog("Worked [".$proxy['host'].':'.$proxy['port']."]", SLOG_OK);
	    }
    }
    mysql_free_result($pr_res);
}
while( (time()-$stime) < $stimeout or $stimeout==0 );


// TERMINATE
curl_close($ch);
slog("Terminated (Proxy Checker): ".(time()-$stime)." sec", SLOG_SYS);
?>