<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */

/**
 * Smarty {append} compiler function plugin
 *
 * Type:     compiler function<br>
 * Name:     append<br>
 * Purpose:  append template variable array
 *
 * @author Igor Shatokhin
 * @link http://www.seostart.com
 *       (Author web site)
 * @param string containing var-attribute and value-attribute
 * @param Smarty_Compiler
 */
function smarty_compiler_append($tag_attrs, &$compiler)
{
    $_params = $compiler->_parse_attrs($tag_attrs);

    if( !isset($_params['var']) )
    {
        $compiler->_syntax_error("append: missing 'var' parameter", E_USER_WARNING);
        return;
    }

    if( !isset($_params['value']) )
    {
        $compiler->_syntax_error("append: missing 'value' parameter", E_USER_WARNING);
        return;
    }

    $merge = empty($_params['merge']) ? 'false' : 'true';

    return "\$this->append({$_params['var']}, {$_params['value']}, {$merge});";
}

/* vim: set expandtab: */

?>
