<?php
//
// by Razor
// igshat@gawab.com
//

define('PROJECT_FILE', 'settings');
include_once(dirname(__FILE__).'/../common.php');
include_once(dirname(__FILE__).'/../lib/func.parser.php');

if( !empty($_POST) ) {
    if( $_POST['action']=='interface' ) {
        set_opt('lang', $_POST['lang']);
        set_opt('style', $_POST['style']);
        set_opt('per_page', intval($_POST['per_page']) );
        $fw->locate('system/settings.php');
    }

    if( $_POST['action']=='login'
    and $fw->rule($_POST['login'], 'login', $fw->conf('err_login') )
    and $fw->rule($_POST['pass'], 'pass', $fw->conf('err_pass') )
    and $fw->assert($_POST['confirm']==$_POST['pass'], $fw->conf('err_pass_cfm') )
    and $fw->assert(!$CONF['demo'], $fw->conf('err_demo') )      ) {
        set_opt('login', $_POST['login']);
        set_opt('pass', md5($_POST['pass']) );
        $fw->conf_inf('inf_data_saved');
    }

    if( $_POST['action']=='security'
    and $fw->rule($_POST['key_code'], 'key_code', $fw->conf('err_key_code') )
    and $fw->assert(!$CONF['demo'], $fw->conf('err_demo') )      ) {
        set_opt('key_code', $_POST['key_code']);
        $fw->conf_inf('inf_data_saved');
    }

    if( $_POST['action']=='testing_config'
    and $fw->assert(!$CONF['demo'], $fw->conf('err_demo'))    ) {
        if( empty($_POST['auto']) ) {
            set_opt('info_url', $_POST['info_url']);
            set_opt('request_timeout', intval($_POST['request_timeout']) );
            set_opt('anon_determ', _safe_var($_POST['anon_determ'],0) );
            set_opt('country_determ', _safe_var($_POST['country_determ'],0) );
            set_opt('security', $_POST['security']);
            set_opt('check_interval', intval($_POST['check_interval']) );
            set_opt('ping', _safe_var($_POST['ping'],0) );
            $fw->conf_inf('inf_data_saved');
        } else {
            // SET TEST PAGE
            $info_url = $fw->url.'tools/info.php';
            set_opt('info_url', $info_url);

            // SET SECURITY FIELDS
            if( !function_exists('curl_exec') ) die('cURL library is not found');
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_URL, $info_url);
            curl_setopt($ch, CURLOPT_TIMEOUT, 30);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
            $content = curl_exec($ch);
            if( !stristr($content, "REQUEST_INFO_PAGE_4896485_CODE") ) $fw->conf_err('err_info_url','',$info_url);
            else {
                $addr = detach_addresses($content);
                $sec = implode("\r\n", $addr);
                set_opt('security', $sec);
                $fw->conf_inf('i_auto');
            }
            curl_close($ch);
        }
    }
}

//
// LANGUAGES
//
$lang_list = array();
$dir = dir($fw->dir.'configs/');
while( false!==($entry=$dir->read()) )
    if( preg_match("|^.+\.lng$|i", $entry) ) $lang_list[] = $entry;
$dir->close();
sort($lang_list);
$fw->assign('lang_list', $lang_list );

//
// STYLES
//
$style_list = array();
$dir = dir($fw->dir.'css/');
while( false!==($entry=$dir->read()) )
    if( preg_match("|^.+\.css$|i", $entry) ) $style_list[] = $entry;
$dir->close();
sort($style_list);
$fw->assign('style_list', $style_list );

//
// GET CHANGED DB CONFIG
//
$DBCONF = $db->sql2array("SELECT * FROM `".$CONF['tbl_conf']."`", 'name');
foreach($DBCONF as $key=>$val) $DBCONF[$key] = $val['value'];

$fw->assign('dbconf', $DBCONF );
$fw->assign('file', PROJECT_FILE);
$fw->display('index.tpl');





function set_opt($name, $value) {
    global $db, $CONF;
    $sql = "UPDATE `".$CONF['tbl_conf']."` SET value='".addslashes($value)."' WHERE name='".addslashes($name)."'";
    $db->query($sql) or die($db->error());
}
?>