<?php
//
// by Razor
// igshat@gawab.com
//

define('PROJECT_FILE', 'proxy_check');
include_once(dirname(__FILE__).'/../common.php');
include_once(dirname(__FILE__).'/../lib/func.parser.php');

_safe_var($_SESSION['check_status'], 'stop');
set_time_limit(30 + $DBCONF['request_timeout']);

//
// PROCESS CONTROL
//
if( !empty($_POST) ) {
    if( isset($_POST['pause']) ) {              // PAUSE / RESUME
        if( $_SESSION['check_status']=='run' ) $_SESSION['check_status']='stop';
        elseif( !empty($_SESSION['check_proxy']) and $_SESSION['check_status']=='stop' ) $_SESSION['check_status']='run';
    }
    elseif( isset($_POST['clear']) ) {          // CLEAR
        $_SESSION['check_proxy'] = false;
    }
    else {                                      // START
        $_SESSION['check_proxy'] = false;
        $adr = detach_addresses($_POST['content']);
        if( empty($adr) ) {
            $_SESSION['check_status'] = 'stop';
            $fw->conf_err('err_search_pr_addr');
        } else {
            $_SESSION['check_status'] = 'run';
            $proxy = array();
            foreach($adr as $val) {
                // HOST : PORT
                if( preg_match("|^(.+)\:(\d+)$|", $val, $m) ) {
                    $host = $m[1];
                    $port = $m[2];
                } else {
                    $host = $val;
                    $port = 80;
                }
                $proxy[] = array('host'=>$host, 'port'=>$port, 'work'=>false, 'post'=>false, 'ref'=>false, 'cookies'=>false, 'anon'=>false, 'contime'=>false, 'time'=>false, 'country'=>false, 'country_code'=>false );
            }
            $_SESSION['check_proxy'] = $proxy;
        }
    }
}

//
// CHECK
//
if( $_SESSION['check_status']=='run' and !empty($_SESSION['check_proxy']) ) {
    $_SESSION['check_status']='stop';
    foreach($_SESSION['check_proxy'] as $key=>$val)
        if($val['work']===false) {
            $_SESSION['check_status']='run';
            $lnk = &$_SESSION['check_proxy'][$key];

            //
            // CURL INIT
            //
            if( !function_exists('curl_exec') ) die('cURL library is not found');
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_URL, $DBCONF['info_url']);
            curl_setopt($ch, CURLOPT_TIMEOUT, $DBCONF['request_timeout']);
            curl_setopt($ch, CURLOPT_USERAGENT, $CONF['user_agent']);
            curl_setopt($ch, CURLOPT_HEADER, 0);
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 0);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($ch, CURLOPT_REFERER, "proxy_test_referer" );
            curl_setopt($ch, CURLOPT_POST, 1);
            curl_setopt($ch, CURLOPT_POSTFIELDS, "ptest=proxy_test_post" );
            curl_setopt($ch, CURLOPT_COOKIE, "ptest=proxy_test_cookie" );

            //
            // LOAD SECURITY PARAMETERS
            //
            $security = array();
            if( preg_match_all("|([^\r\n]+)|", $DBCONF['security'], $m) ) {
                foreach($m[1] as $v)
                    $security[] = trim($v);
            }
            else die('Empty security parameters');

            //
            // COUNTRY
            //
            $country = '';
            $country_code = '';
            $ip = gethostbyname($val['host']);
            $longip = sprintf("%u", ip2long($ip));
            $sql = "SELECT * FROM `".$CONF['tbl_country']."` "
                 . "WHERE ip_start<".$longip." "
                 . "AND ip_end>".$longip." "
                 . "LIMIT 0,1";
            $res = $db->sql2array($sql);
            if($db->error()) die($db->error());
            if( !empty($res) ) {
                $res = @reset($res);
                $country = $res['name'];
                $country_code = $res['zone2'];
            }
            $lnk['country'] = $country;
            $lnk['country_code'] = $country_code;

            //
            // CHECK PROXY
            //
            curl_setopt($ch, CURLOPT_PROXY, $val['host'].':'.$val['port'] );
            $content = curl_exec($ch);

            //
            // TIME
            //
            $lnk['contime'] = curl_getinfo($ch, CURLINFO_CONNECT_TIME);
            $lnk['time'] = curl_getinfo($ch, CURLINFO_TOTAL_TIME);

            //
            // ANALYSE RESULT
            //
            if( !stristr($content, "REQUEST_INFO_PAGE_4896485_CODE") ) {
                $lnk['work'] = 0;
                $lnk['post'] = 0;
                $lnk['ref'] = 0;
                $lnk['cookies'] = 0;
                $lnk['anon'] = 0;
            }
            else {
                $lnk['work'] = 1;

                //
                // POST
                //
                stristr($content, "proxy_test_post") ?
                $post = 1 : $post = 0;
                $lnk['post'] = $post;

                //
                // REFERER
                //
                stristr($content, "proxy_test_referer") ?
                $ref = 1 : $ref = 0;
                $lnk['ref'] = $ref;

                //
                // COOKIES
                //
                stristr($content, "proxy_test_cookie") ?
                $cookies = 1 : $cookies = 0;
                $lnk['cookies'] = $cookies;

                //
                // ANONYMOUS
                //
                $anon = 1;
                foreach($security as $v) {
                    if( stristr($content, $v) ) { $anon = 0; break; }
                }
                if($anon) {
                    // TEST FOR HIGHT ANONYMITY
                    $anon = 2;
                    if( preg_match_all("|([^\r\n]+)=([^\r\n]+)|", $content, $m, PREG_SET_ORDER) )
                        foreach($m as $v) {
                            if( $v[1]=='HTTP_X_FORWARDED_FOR'
                            or $v[1]=='HTTP_X_FORWARDED'
                            or $v[1]=='HTTP_X_COMING_FROM'
                            or $v[1]=='HTTP_FORWARDED_FOR'
                            or $v[1]=='HTTP_FORWARDED'
                            or $v[1]=='HTTP_COMING_FROM'
                            or $v[1]=='HTTP_VIA'
                            or $v[1]=='HTTP_XROXY_CONNECTION'
                            or $v[1]=='HTTP_PROXY_CONNECTION' ) $anon = 1;
                        }
                }
                $lnk['anon'] = $anon;
            }

            curl_close($ch);
            break;
        }

}

if($_SESSION['check_status']=='run')
    $fw->assign('onload', "refresh()" );

$fw->assign('SID', $_SID);
$fw->assign('file', PROJECT_FILE);
$fw->display('index.tpl');
?>